"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var schematics_1 = require("@angular-devkit/schematics");
var workspace_1 = require("@schematics/angular/utility/workspace");
function updateNpmScript(tree, logger) {
    var _a;
    var pkgPath = '/package.json';
    var buffer = tree.read(pkgPath);
    if (buffer === null) {
        throw new schematics_1.SchematicsException('Could not read package.json');
    }
    var pkg = JSON.parse(buffer.toString());
    if (pkg === null || typeof pkg !== 'object' || Array.isArray(pkg)) {
        throw new schematics_1.SchematicsException('Error reading package.json');
    }
    if ((_a = pkg.scripts) === null || _a === void 0 ? void 0 : _a['extract-i18n-merge']) {
        logger.info('updating npm script "extract-i18n-merge" (you can delete it if you like!)..');
        pkg.scripts['extract-i18n-merge'] = 'ng extract-i18n';
    }
    tree.overwrite(pkgPath, JSON.stringify(pkg, null, 2));
}
function default_1() {
    var _this = this;
    return function (tree, context) {
        updateNpmScript(tree, context.logger);
        return (0, workspace_1.updateWorkspace)(function (workspace) { return __awaiter(_this, void 0, void 0, function () {
            var VERSION;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('@angular/core')); })];
                    case 1:
                        VERSION = (_a.sent()).VERSION;
                        workspace.projects.forEach(function (project, projectName) {
                            var _a;
                            var _b, _c, _d, _e, _f;
                            var i18nMergeTarget = project.targets.get('extract-i18n-merge');
                            if (i18nMergeTarget) {
                                context.logger.info("updating extract-i18n(-merge) targets for project ".concat(projectName, ".."));
                                var angularMajorVersion = parseInt(VERSION.major);
                                var buildTargetAttribute = angularMajorVersion >= 17 ? 'buildTarget' : 'browserTarget';
                                var i18nTarget = __assign({}, ((_b = project.targets.get('extract-i18n')) !== null && _b !== void 0 ? _b : { builder: 'ng-extract-i18n-merge:ng-extract-i18n-merge' }));
                                i18nTarget.builder = 'ng-extract-i18n-merge:ng-extract-i18n-merge';
                                i18nTarget.options = __assign(__assign({}, i18nMergeTarget.options), (_a = {}, _a[buildTargetAttribute] = (_f = (_d = (_c = i18nTarget.options) === null || _c === void 0 ? void 0 : _c.browserTarget) !== null && _d !== void 0 ? _d : (_e = i18nTarget.options) === null || _e === void 0 ? void 0 : _e.buildTarget) !== null && _f !== void 0 ? _f : "".concat(projectName, ":build"), _a));
                                project.targets.delete('extract-i18n'); // 'project.targets.set' not working!?
                                project.targets.add(__assign({ name: 'extract-i18n' }, i18nTarget));
                                project.targets.delete('extract-i18n-merge');
                            }
                            else {
                                context.logger.warn('target "extract-i18n-merge" not found in workspace - please migrate manually!');
                            }
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    };
}
exports.default = default_1;
