"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TranslationFile = void 0;
var TranslationFile = /** @class */ (function () {
    function TranslationFile(units, sourceLang, targetLang, xmlHeader) {
        this.units = units;
        this.sourceLang = sourceLang;
        this.targetLang = targetLang;
        this.xmlHeader = xmlHeader;
    }
    TranslationFile.prototype.mapUnitsList = function (unitsMapper) {
        return new TranslationFile(unitsMapper(this.units), this.sourceLang, this.targetLang, this.xmlHeader);
    };
    TranslationFile.prototype.replaceUnit = function (unit, updated) {
        var index = this.units.findIndex(function (u) { return u.id === unit.id; }); // TODO performance?
        if (index === -1) {
            throw new Error("Unit ".concat(unit.id, " not found"));
        }
        this.units[index] = updated;
    };
    TranslationFile.prototype.addUnit = function (updated) {
        this.units.push(updated);
    };
    return TranslationFile;
}());
exports.TranslationFile = TranslationFile;
