"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.doCollapseWhitespace = void 0;
// Converts sequences of space, tabs and "section breaks" like linefeeds and
// carriage returns to a single space, but leaving other space characters like
// no-break-space (U+00A0) intact.
// Refer to https://developer.mozilla.org/en-US/docs/Web/CSS/white-space-collapse#collapsing_of_white_space
function doCollapseWhitespace(destSourceText) {
    return destSourceText === null || destSourceText === void 0 ? void 0 : destSourceText.replace(/[\n\r\t ]+/g, ' ');
}
exports.doCollapseWhitespace = doCollapseWhitespace;
